# coding: utf-8

"""
    Gitea API

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.21.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictInt, StrictStr
from pydantic import Field
from py_gitea_opensuse_org.models.issue import Issue
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class TrackedTime(BaseModel):
    """
    TrackedTime worked time for an issue / pr
    """ # noqa: E501
    created: Optional[datetime] = None
    id: Optional[StrictInt] = None
    issue: Optional[Issue] = None
    issue_id: Optional[StrictInt] = Field(default=None, description="deprecated (only for backwards compatibility)")
    time: Optional[StrictInt] = Field(default=None, description="Time in seconds")
    user_id: Optional[StrictInt] = Field(default=None, description="deprecated (only for backwards compatibility)")
    user_name: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["created", "id", "issue", "issue_id", "time", "user_id", "user_name"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TrackedTime from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of issue
        if self.issue:
            _dict['issue'] = self.issue.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of TrackedTime from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "created": obj.get("created"),
            "id": obj.get("id"),
            "issue": Issue.from_dict(obj.get("issue")) if obj.get("issue") is not None else None,
            "issue_id": obj.get("issue_id"),
            "time": obj.get("time"),
            "user_id": obj.get("user_id"),
            "user_name": obj.get("user_name")
        })
        return _obj


